move(state(middle, on_box, middle, has_not),
     grasp,
     state(middle, on_box, middle, has)).
move(state(P, on_floor, P, H),
     climb,
     state(P, on_box, P, H)	).
move(state(P1, on_floor, P1, H),
     push(P1, P2),
     state(P2, on_floor, P2, H)).
move(state(P1, on_floor, P, H), walk(P1, P2), state(P2, on_floor, P, H)).


canget(state(_, _, _, has)).
canget(OldState) :-
	move(OldState, _Move, NewState),
	canget(NewState).

canget(state(_, _, _, has),[]).
canget(OldState,[Move|Actions]) :-
	move(OldState, Move, NewState),
	canget(NewState,Actions).

natlist(0,[0]).
natlist(N,L):-
	N > 0,
	N1 is N-1,
	natlist(N1, L1),
	append(L1, [N], L).

fak(0, 1).
fak(N, F) :-
    N > 0,
    N1 is N - 1,
    fak(N1, F1),
    F is F1 * N.

fak_acc(N, F) :-
    fac_acc(N, 1, F).

fac_acc(0, F, F).
fac_acc(N, F1, F):-
    N > 0,
    F2 is N * F1,
    N2 is N - 1,
    fac_acc(N2, F2, F).
    
    

naive_sort(L, L1):-
    permutation(L,L1),
    sorted(L1).

permutation([],[]).
permutation(L, [X|L3]):-
    remove(X, L, L2),
    permutation(L2, L3).

remove(X, [X|L], L).
remove(X, [H|T], [H|L]):-
    remove(X, T, L).

sorted([]).
sorted([_X]).
sorted([X,Y|T]):-
       X < Y,
       sorted([Y|T]).



naive_sort_flexible(L, L1):-
    same_length(L,L1),
    permutation(L,L1),
    sorted(L1).


same_length([],[]).
same_length([_H1|T1],[_H2|T2]):-
	same_length(T1, T2).

delay_sort(L, L1):-
	same_length(L, L1),
	delay_sorted(L1),
	permutation(L, L1).

delay_sorted([]).
delay_sorted([_X]).
delay_sorted([X,Y|T]):-
    when(ground((X,Y)), X < Y),
    delay_sorted([Y|T]).
    
    
var_list(0, []).
var_list(N, [X|T]):-
    N > 0,
    N1 is N - 1,
    var_list(N1, T).


quicksort([],[]).
quicksort([Head|Tail], L1):-
   partition(Tail, Head,  Littles, Bigs),
   quicksort(Littles, SortedLittles),
   quicksort(Bigs, SortedBigs),
   append(SortedLittles,[Head|SortedBigs], L1).
    
partition([],N,[],[]).
partition([Head|Tail],N,[Head|Littles],Bigs):-
    Head < N,
    partition(Tail,N,Littles,Bigs).
partition([Head|Tail],N,Littles,[Head|Bigs]):-
    Head >= N,
    partition(Tail,N,Littles,Bigs).


:- dynamic student_of/2.
    
parent(john,peter).
parent(john,paul).
parent(john,mary).
parent(mick,davy).
parent(mick,dee).
parent(mick,dozy).

fib_slow(1,1).
fib_slow(2,1).
fib_slow(N,F):-
    N > 2,
    N1 is N-1,
    N2 is N-2,
    fib_slow(N1, F1),
    fib_slow(N2, F2),
    F is F1 + F2.
    

:- dynamic fib_fast/2.

fib_fast(1,1).
fib_fast(2,1).
fib_fast(N,F):-
    N > 2,
    N1 is N-1,
    N2 is N-2,
    fib_fast(N1, F1),
    fib_fast(N2, F2),
    F is F1 + F2,
    asserta(fib_fast(N,F)).
    


:-dynamic fib_fast_2/2.

fib_fast_2(1,1).
fib_fast_2(2,1).
fib_fast_2(N,F):-
    N > 2,
    N1 is N-1,
    N2 is N-2,
    fib_fast_2(N1, F1),
    fib_fast_2(N2, F2),
    F is F1 + F2,
    asserta(fib_fast_2(N,F)),
    replace_fib(N).

replace_fib(N1):-
	retract((fib_fast_2(N,F) :-
	N > _,
	N1 is N-1,
	N2 is N-2,
	fib_fast_2(N1, F1),
	fib_fast_2(N2, F2),
	F is F1 + F2,
	asserta(fib_fast_2(N,F)),
	replace_fib(N))),
	assertz((fib_fast_2(N,F) :-
	N > N1,
	N1 is N-1,
	N2 is N-2,
	fib_fast_2(N1, F1),
	fib_fast_2(N2, F2),
	F is F1 + F2,
	asserta(fib_fast_2(N,F)),
	replace_fib(N))).


funct(T, F, N) :-
	nonvar(T),
	T =.. [F|Args],
	length(Args, N).


generate([L1, L2, L3, L4, L5, L6, L7, L8, L9]):-
    Numbers = [1,2,3,4,5,6,7,8,9],
    permutation(Numbers, L1),
    permutation(Numbers, L2),
    permutation(Numbers, L3),
    permutation(Numbers, L4),
    permutation(Numbers, L5),
    permutation(Numbers, L6),
    permutation(Numbers, L7),
    permutation(Numbers, L8),
    permutation(Numbers, L9).

allunequal_qs(L):-
	quicksort_delay(L, [1,2,3,4,5,6,7,8,9]).

allunequal([]).
allunequal([H|T]):-
	not_contained(H, T),
	allunequal(T).

not_contained(_X, []).
not_contained(X, [H|T]) :-
	when(ground((X,H)), X =\= H),
	not_contained(X, T).


test_blocks(
	[X1, X2, X3, X4, X5, X6, X7, X8, X9],
	[Y1, Y2, Y3, Y4, Y5, Y6, Y7, Y8, Y9],
	[Z1, Z2, Z3, Z4, Z5, Z6, Z7, Z8, Z9]):-
	allunequal([X1, X2, X3, Y1, Y2, Y3, Z1, Z2, Z3]),
	allunequal([X4, X5, X6, Y4, Y5, Y6, Z4, Z5, Z6]),
	allunequal([X7, X8, X9, Y7, Y8, Y9, Z7, Z8, Z9]).
	
test_columns([],[],[],[],[],[],[],[],[]).
test_columns([H1|T1],[H2|T2],[H3|T3],[H4|T4],[H5|T5],[H6|T6],[H7|T7],[H8|T8],[H9|T9]):-
	allunequal([H1,H2,H3,H4,H5,H6,H7,H8,H9]),
	test_columns(T1,T2,T3,T4,T5,T6,T7,T8,T9).

	

test([L1, L2, L3, L4, L5, L6, L7, L8, L9]):-
	test_columns(L1, L2, L3, L4, L5, L6, L7, L8, L9),
	test_blocks(L1,L2,L3),
	test_blocks(L4,L5,L6),
	test_blocks(L7,L8,L9).


quicksort_delay([],[]).
quicksort_delay([Head|Tail], L1):-
	same_length([Head|Tail], L1),
	partition_delay(Tail, Head,  Littles, Bigs),
	quicksort_delay(Littles, SortedLittles),
	quicksort_delay(Bigs, SortedBigs),
	append(SortedLittles,[Head|SortedBigs], L1).
    
partition_delay([],N,[],[]).
partition_delay([Head|Tail],N,[Head|Littles],Bigs):-
	when(ground((Head, N)),Head < N),
	partition_delay(Tail,N,Littles,Bigs).
partition_delay([Head|Tail],N,Littles,[Head|Bigs]):-
	when(ground((Head, N)), Head >= N),
	partition_delay(Tail,N,Littles,Bigs).


sudoku(L):-
	test(L),generate(L).


write_sudoku(L):-
	forall(member(X, L), (write(X), nl)).


my_sudoku([
	[_, 8, _, 7, _, _, 6, 3, _],
	[5, _, _, _, _, _, 1, _, _],
	[_, _, _, 8, 2, 3, _, _, _],
	[_, 1, _, _, 7, _, _, 9, _],
	[_, _, 3, _, _, _, 5, _, _],
	[_, 4, _, _, 9, _, _, 2, _],
	[_, _, _, 2, 3, 5, _, _, _],
	[_, _, 4, _, _, _, _, _, 3],
	[_, 5, 9, _, _, 8, _, 7, _]
    ]).
hard_sudoku([
	[1, _, 5, _, _, _, _, _, 4],
	[_, _, _, 7, _, _, 2, 9, _],
	[7, 2, 9, 6, _, _, _, _, _],
	[2, _, _, _, 3, _, _, _, 6],
	[4, _, _, _, _, _, _, _, 5],
	[9, _, _, _, 8, _, _, _, 1],
	[_, _, _, _, _, 2, 8, 4, 7],
	[_, 4, 7, _, _, 5, _, _, _],
	[6, _, _, _, _, _, 3, _, 9]
    ]).
hardest_sudoku([
	[8, 5, _, _, _, 2, 4, _, _],
	[7, 2, _, _, _, _, _, _, 9],
	[_, _, 4, _, _, _, _, _, _],
	[_, _, _, 1, _, 7, _, _, 2],
	[3, _, 5, _, _, _, 9, _, _],
	[_, 4, _, _, _, _, _, _, _],
	[_, _, _, _, 8, _, _, 7, _],
	[_, 1, 7, _, _, _, _, _, _],
	[_, _, _, _, 3, 6, _, 4, _]
    ]).
naive_sudoku([
	[_, _, _, _, _, _, _, _, _],
	[_, _, _, _, _, _, _, _, _],
	[_, _, _, _, _, _, _, _, _],
	[_, _, _, _, _, _, _, _, _],
	[_, _, _, _, _, _, _, _, _],
	[_, _, _, _, _, _, _, _, _],
	[_, _, _, _, _, _, _, _, _],
	[_, _, _, _, _, _, _, _, _],
	[_, _, _, _, _, _, _, _, _]
    ]).







bachelor(X):-
	man(X),not(married(X)).
man(fred).
man(peter).
married(fred).




likes(peter, Y) :- friendly(Y).
likes(T, S) :- student_of(S, T).
student_of(maria, peter).
student_of(paul, peter).
friendly(maria).


max(X,Y,X):-X>=Y.
max(X,Y,Y):-X<Y.

max_cut(X,Y,X):-X>=Y,!.
max_cut(X,Y,Y).


solution1(L):-
    generate1(L),
    test1(L).

generate1([ S, E, N, D,
	    M, O, R, E,
	M, O, N, E, Y]):-
    remove(S, [1, 2, 3, 4, 5, 6, 7, 8, 9, 0], L1),
    remove(E, L1, L2),
    remove(N, L2, L3),
    remove(D, L3, L4),
    remove(M, L4, L5),
    remove(O, L5, L6),
    remove(R, L6, L7),
    member(Y, L7).

test1([ S, E, N, D,
        M, O, R, E,
     M, O, N, E, Y]):-
%	S =\=0,
%	M =\= 0,
	Y is (D + E) mod 10,
	C1 is (D + E) // 10,
	E is (R + N + C1) mod 10,
	C2 is (R + N + C1) // 10,
	N is (O + E + C2) mod 10,
	C3 is (O + E + C2) // 10,
	O is (S + M + C3) mod 10,
	M is (S + M + C3) // 10.

solution1Fast([ S, E, N, D,
	    M, O, R, E,
	M, O, N, E, Y]):-
	remove(D, [1, 2, 3, 4, 5, 6, 7, 8, 9, 0], L1),
	remove(E, L1, L2),
	remove(Y, L2, L3),
	Y is (D + E) mod 10,
	C1 is (D + E) // 10,
	remove(N, L3, L4),
	remove(R, L4, L5),
	E is (R + N + C1) mod 10,
	C2 is (R + N + C1) // 10,
	remove(O, L5, L6),
	N is (O + E + C2) mod 10,
	C3 is (O + E + C2) // 10,
	remove(S, L6, L7),
	remove(M, L7, L8),
	O is (S + M + C3) mod 10,	
	M is (S + M + C3) // 10.
	

solution1Delay(L):-
	test1Delay(L),
	generate1Delay(L).

test1Delay([ S, E, N, D,
             M, O, R, E,
          M, O, N, E, Y]):-
	when(ground(D + E),(Y is (D + E) mod 10, C1 is (D + E) // 10)),
	when(ground(R + N + C1), (E is (R + N + C1) mod 10, C2 is (R + N + C1) // 10)),
	when(ground(O + E + C2), (N is (O + E + C2) mod 10, C3 is (O + E + C2) // 10)),
	when(ground(S + M + C3), (O is (S + M + C3) mod 10, M is (S + M + C3) // 10)).
    

generate1Delay([ S, E, N, D,
	         M, O, R, E,
	      M, O, N, E, Y]):-
    remove(D, [1, 2, 3, 4, 5, 6, 7, 8, 9, 0], L1),
    remove(E, L1, L2),
    remove(Y, L2, L3),
    remove(N, L3, L4),
    remove(R, L4, L5),
    remove(O, L5, L6),
    remove(S, L6, L7),
    member(M, L7).


magic_number([X1, X2, X3, X4, X5, X6, X7, X8, X9]):-
	permutation([1, 2, 3, 4, 5, 6, 7, 8, 9],
	[X1, X2, X3, X4, X5, X6, X7, X8, X9]),
	0 is X2 mod 2,
	0 is (X1 + X2 + X3) mod 3,
	0 is (X3 * 10 + X4) mod 4,
	0 is X5 mod 5,
	0 is X6 mod 2, 0 is (X1 + X2 + X3 + X4 + X5 + X6) mod 3,
	0 is ((((((((X1 * 10) + X2) * 10 + X3) * 10) + X4) * 10 + X5) * 10 + X6)*10 + X7) mod 7,
	0 is ((X6 * 10 + X7) * 10 + X8) mod 8.  

magic_number_fast([X1, X2, X3, X4, X5, X6, X7, X8, X9]):-
	L = [1, 2, 3, 4, 5, 6, 7, 8, 9],
	remove(X1, L, L1),
	remove(X2, L1, L2),
	0 is X2 mod 2,
	remove(X3, L2, L3),
	0 is (X1 + X2 + X3) mod 3,
	remove(X4, L3, L4),
	0 is (X3 * 10 + X4) mod 4,
	remove(X5, L4, L5),
	0 is X5 mod 5,
	remove(X6, L5, L6),
	0 is X6 mod 2,
	0 is (X1 + X2 + X3 + X4 + X5 + X6) mod 3,
	remove(X7, L6, L7),
	0 is ((((((((X1 * 10) + X2) * 10 + X3) * 10) + X4) * 10 + X5) * 10 + X6)*10 + X7) mod 7,
	remove(X8, L7, [X9]),
	0 is ((X6 * 10 + X7) * 10 + X8) mod 8.  


magic_number_delay([X1, X2, X3, X4, X5, X6, X7, X8, X9]):-
	when(ground(X2), 0 is X2 mod 2),
	when(ground(X1 + X2 + X3), 0 is (X1 + X2 + X3) mod 3),
	when(ground(X3+X4), 0 is (X3 * 10 + X4) mod 4),
	when(ground(X5), 0 is X5 mod 5),
	when(ground(X6), 0 is X6 mod 2),
	when(ground(X1 + X2 + X3 + X4 + X5 + X6), 0 is (X1 + X2 + X3 + X4 + X5 + X6) mod 3),
	when(ground(X1 + X2 + X3 + X4 + X5 + X6 + X7),0 is ((((((((X1 * 10) + X2) * 10 + X3) * 10) + X4) * 10 + X5) * 10 + X6)*10 + X7) mod 7),
	when(ground(X6+X7+X8), 0 is ((X6 * 10 + X7) * 10 + X8) mod 8),
	permutation([1, 2, 3, 4, 5, 6, 7, 8, 9],
	[X1, X2, X3, X4, X5, X6, X7, X8, X9]).






